GoJS® Diagramming Components
version 1.6.19 for JavaScript/HTML
by Northwoods Software®

## Class ContextMenuTool

Extends Tool. The ContextMenuTool is used to create and show a context menu. It automatically disables any browser context menu.

Define context menus on individual GraphObjects by setting GraphObject.contextMenu. Define a context menu for the diagram background by setting Diagram.contextMenu.

This tool is a standard mouse-down tool, the ToolManager.contextMenuTool.

This tool does not utilize any tool handles. This tool does not modify the model or conduct any transaction, although any code invoked by context menu commands might do so.

There are examples of customizing this tool in the Custom Context Menu and HTML LightBox Context Menu samples.

If you want to programmatically show a context menu for a particular GraphObject or for the whole diagram, call CommandHandler.showContextMenu. That command method is also invoked by the Menu key on the keyboard.

Normally this shows a context menu (if available) on a right-mouse-up event. If you want it to happen on a right-mouse-down event, you'll need to move this tool from the ToolManager.mouseUpTools list to the ToolManager.mouseDownTools list:

    myDiagram.toolManager.mouseDownTools.add(myDiagram.toolManager.replaceTool("ContextMenu", null));

## Constructor Summary Details

Name | Description
--- | ---
ContextMenuTool() | You do not normally need to create an instance of this tool because one already exists as the ToolManager.contextMenuTool, which you can modify.More...

## Properties Summary Details

Name, Value Type | Description
--- | ---
currentContextMenu {Adornment} | Gets or sets the currently showing context menu, or null if there is none.More... This is typically only set in showContextMenu and not by the user. It is also typically set to null in hideContextMenu.
currentObject {GraphObject} 1.4 | Gets or sets the GraphObject found at the mouse point that has a context menu.More... This property remembers the result returned by findObjectWithContextMenu if it is a GraphObject. This value is passed to showContextMenu as the second argument. The value will be null if the context menu is for the diagram rather than for a particular GraphObject.
mouseDownPoint {Point} | This read-only property returns the original mouse-down point in document coordinates.

Properties borrowed from class Tool:
  diagram, isActive, isEnabled, name, transactionResult

## Method Summary Details

Name, Return Type | Description
--- | ---

canStart()
{boolean}

Return true if it's a mouse right click that hasn't moved Tool.isBeyondDragSize and that is on a GraphObject with a GraphObject.contextMenu.More... This is also true if the mouse right click is in the diagram background and the diagram's Diagram.contextMenu is non-null.

On touch devices, a special default context menu will appear even if no object with a context menu is found.

This method may be overridden.

Returns:
{boolean}

doActivate() | Do nothing, activation is special and relies on doMouseUp
doMouseDown() | Activate this but also execute the normal behavior that would happen on a mouse-up if this tool is in the ToolManager.mouseDownTools list.
doMouseMove() | Handle mouse-enter, mouse-over, and mouse-leave events, as well as tooltips.

doMouseUp()

If there is something found by findObjectWithContextMenu, call showContextMenu with that object's GraphObject.contextMenu or the Diagram.contextMenu.More... If nothing is found or there is no context menu, call showDefaultContextMenu.

Once a context menu is being shown, if a click occurs on a part of the context menu, call Tool.standardMouseClick. Otherwise if the click occurs elsewhere, just stop this tool. Unlike most tools, the first mouse-up should not stop this tool.

findObjectWithContextMenu(obj)
{GraphObject|Diagram}

Find a GraphObject at the current mouse point with a GraphObject.contextMenu, or return the Diagram if there is a Diagram.contextMenu.More...

Parameters:
{GraphObject|Diagram=} obj
  Optional GraphObject with which to start searching for a context menu. If null, the Diagram will be used. If no argument is specified, this method will look for an object at the current mouse point.

Returns:
{GraphObject|Diagram} something with a `contextMenu`, or null if nothing can be found with a context menu at the current mouse point.

hideContextMenu() | Hide any context menu.More...
hideDefaultContextMenu() | Hide the default context menu.More...

positionContextMenu(contextmenu, obj)

This is called by showContextMenu to position the context menu within the viewport.More... It normally goes just below the cursor. But if the mouse is too close to the right edge or the bottom edge of the viewport, it is positioned left and/or above the cursor.

Parameters:
{Adornment} contextmenu
{GraphObject} obj
  The GraphObject getting the context menu, or null if the context menu is for the diagram background.

showContextMenu(contextmenu, obj)

Show an Adornment as a context menu.More...

Parameters:
{Adornment} contextmenu
{GraphObject} obj
  the GraphObject for which the context menu is being shown; this is null if the contextmenu is being shown for the diagram background.

showDefaultContextMenu() | Show a series of HTML elements acting as a context menu.More...

Methods borrowed from class Tool:
  cancelWaitAfter, canStartMultiTouch, doCancel, doDeactivate, doKeyDown, doKeyUp, doMouseWheel, doStart, doStop, doWaitAfter, findToolHandleAt, isBeyondDragSize, standardMouseClick, standardMouseOver, standardMouseSelect, standardMouseWheel, standardPinchZoomMove, standardPinchZoomStart, standardWaitAfter, startTransaction, stopTool, stopTransaction, updateAdornments